namespace Leon.TcpThread
{
 using System;
 using System.Threading;
 using Leo.LeonForm;
 using System.Windows.Forms;
 using System.Diagnostics;
 using System.Net.Sockets;
 using System.Net;
 using System.Text;

 internal class TCPWorker
 {
  private MainForm form = null; 
  public MainForm TCPForm
  {
      set
      {
       form = value;
      }
  }
  private string ip = null;
  public string SelectedIP
  {
      set
      {
       ip = string.Copy(value);
      }
  }
  public void Run()
  {
   TcpListener myListener = null;
   Socket mySocket = null;
   try
   {
    if(form == null || ip == "" || ip == null)
    {
     MessageBox.Show("You must set TCPForm");
     return;
    }  
    //MessageBox.Show(ip);
    myListener = new TcpListener(new IPEndPoint(IPAddress.Parse(ip), 80));
    Encoding ASCII = Encoding.ASCII;
    myListener.Start();
    while(true)
    {
     if(myListener.Pending())
     {
      mySocket = myListener.AcceptSocket();
      byte []recv = new byte[1024];
      int bytecount = mySocket.Receive(recv);
      string SendString = "HTTP/1.0 200 OK\x0d\x0aServer: FirstSteps/0.1\x0d\x0a\x0d\x0a";   
      mySocket.Send(ASCII.GetBytes(SendString));
      SendString = "<html><title>Socket example</title><body>" + ASCII.GetString(recv, 0, bytecount);
      SendString += "</body></html>";
      mySocket.Send(ASCII.GetBytes(SendString));
      mySocket.Close();
     }
     Thread.Sleep(100);
    }
   }catch(ThreadAbortException)
   {
     if(myListener != null)
       myListener.Stop();
   }
   finally
   {
    myListener = null;
    Debug.WriteLine("Stop thread"); 
    if(mySocket != null)
        mySocket.Close();
   }
  }
 }
}